static char rcsid[] = "@(#)$Id: conf_writer.c,v 1.1.4.1 2006/08/27 11:17:21 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.1.4.1 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@posti.FMI.FI> 
 *      or  Kari Hurtta <elm@elmme-mailer.org>
 *****************************************************************************/


#include "def_misc.h"
#include "s_me.h"

DEBUG_VAR(Debug,__FILE__,"config");

static struct config_files {
    char * shortname;
    char *fname;
    dump_conf_map_f * dump_map;
    dump_message_f  * write_message;
}          * cfiles = NULL;
static int   cfiles_num = 0;


void register_conf_write(shortname,fname,dump_map,write_message)
     char * shortname;
     char *fname;
     dump_conf_map_f * dump_map;
     dump_message_f  * write_message;
{
    cfiles = safe_realloc(cfiles, 
			  sizeof(cfiles[0]) * (cfiles_num+1));

    cfiles[cfiles_num].shortname     = shortname;
    cfiles[cfiles_num].fname         = fname;
    cfiles[cfiles_num].dump_map      = dump_map;
    cfiles[cfiles_num].write_message = write_message;

    cfiles_num++;
}

void write_conf()
{
    int i;

    for (i = 0; i < cfiles_num; i++) {
	int err;
	FILE *f = NULL;
	char *tmp;

	tmp = elm_message(FRM("%s.N"),cfiles[i].fname);
	err = can_open(tmp,"w");
	if (err)
	    lib_error(CATGETS(elm_msg_cat, MeSet, MeFileNotWriteable,
			      "File %.50s is not writeable: %s"),
		      tmp, strerror(err));
	else if (!(f = fopen(tmp,"w"))) {
	    int err = errno;
	    lib_error(CATGETS(elm_msg_cat, MeSet, MeFileNotWriteable,
			      "File %.50s is not writeable: %s"),
		      tmp, strerror(err));
	} else {
	    cfiles[i].dump_map(f);

	    if (EOF == fclose(f)) {
		int err = errno;
		lib_error(CATGETS(elm_msg_cat, MeSet, MeFileNotWriteable,
				  "File %.50s is not writeable: %s"),
			  tmp, strerror(err));
		
	    } else if (0 != rename(tmp,cfiles[i].fname)) {
		int err = errno;
		lib_error(CATGETS(elm_msg_cat, MeSet, MeFileNotRenamed,
				  "Failed to rename temporary file to %.50s: %30s"),
			  user_iso2022_sets, 
			  strerror(err));
		
	    } else {
		cfiles[i].write_message(cfiles[i].fname);
	    }
	}
	free(tmp);

    }
}

struct string * conf_taglist(sep)
     struct string *sep;

{
    struct string * ret = format_string(FRM("(none)"));

    int i;

    for (i = 0; i < cfiles_num; i++) {
	struct string * X;
					
	
	if (i == cfiles_num-1)
	    X = format_string(FRM("%S %S %s"),
			      ret,sep,cfiles[i].shortname);
	else if (i > 0) 
	    X = format_string(FRM("%S, %s"),
			      ret,cfiles[i].shortname);
	else
	    X = format_string(FRM("%s"),
			      cfiles[i].shortname);
	    
	free_string(&ret);
	ret = X;
    }

    return ret;
}


/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
